function HTMLescape()
{
    var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"];
    scriptLoader = scriptLoader.getService(Components.interfaces.mozIJSSubScriptLoader);
    scriptLoader.loadSubScript("chrome://web-mail/content/common/DebugLog.js");
           
    var  szLogFileName = "HTML escape Log ";
    this.m_Log = new DebugLog("webmail.logging.comms", ExtHotmailGuid, szLogFileName);

    this.m_callback= null;
    this.m_parent = null;
    this.m_szRawMSG = null;
}


HTMLescape.prototype.encode = function(msg)
{
    return msg;
}


//&#00;-&#08;                Unused
//&#11;-&#12;                Unused
//&#14;-&#31;                Unused
//&#32; = \s                 MS not using
//&#44; = ,                  MS not using
//&#45; = -                  MS not using
//&#46; = .                  MS not using
//&#48;-&#57;      0-9       Digits 0-9
//&#65;-&#90;      A-Z       Letters A-Z
//&#97;-&#122;     a-z       Letters a-z
//&#127;-&#159;              Unused
//&#160;-&#255               Unlikely
HTMLescape.prototype.decode = function(rawMSG)
{
    try
    {
        var szMSG = rawMSG;
     
        //most likely
        szMSG = szMSG.replace(/&#(\d+);/g,function(){return String.fromCharCode(RegExp.$1);});
        if (szMSG.search(/&#x200F;/ig)!=-1) szMSG = szMSG.replace(/&#x200F;/igm, ""); //right-to-left mark ?
                 
        //some more MS use
        if (szMSG.search(/&lt;/g)!=-1) szMSG = szMSG.replace(/&lt;/gm,"<");
        if (szMSG.search(/&gt;/g)!=-1) szMSG = szMSG.replace(/&gt;/gm,">");
        if (szMSG.search(/&quot;/g)!=-1) szMSG = szMSG.replace(/&quot;/gm,"\"");
        if (szMSG.search(/&amp;/g)!=-1) szMSG = szMSG.replace(/&amp;/gm,"&");
        if (szMSG.search(/&nbsp;/g)!=-1) szMSG = szMSG.replace(/&nbsp;/gm," ");
        if (szMSG.search(/&apos;/g)!=-1) szMSG = szMSG.replace(/&apos;/gm,"\'");
        if (szMSG.search(/\r/g)!=-1) szMSG = szMSG.replace(/\r/gm,"");
        if (szMSG.search(/\n/g)!=-1) szMSG = szMSG.replace(/\n/gm,"\r\n");

        return szMSG;
    }
    catch(e)
    {
        DebugDump("HTML-escape.js : Exception in decode "
                                + e.name +
                                ".\nError message: "
                                + e.message + "\n"
                                + e.lineNumber);
        return null;
    }
}



//create worker thread 
HTMLescape.prototype.decodeAsync = function(rawMSG, callback, parent)
{
    try
    {
        this.m_Log.Write("HTMLescape.js - largeDecode - START");
        
        this.m_szRawMSG = rawMSG;        
        this.m_callback = callback;
        this.m_parent = parent;

        var background = Components.classes["@mozilla.org/thread-manager;1"]
                                   .getService()
                                   .newThread(0);
        background.dispatch(new workingThread(this), background.DISPATCH_NORMAL);

        this.m_Log.Write("HTMLescape.js - largeDecode - END");
        return true;
    }
    catch(err)
    {
         this.m_Log.DebugDump("HTMLescape.js: largeDecode : Exception : "
                                          + err.name
                                          + ".\nError message: "
                                          + err.message +"\n"
                                          + err.lineNumber);

        return false;
    }
}



var workingThread = function(htmlObject) 
{
    this.m_HtmlObject = htmlObject;
};


workingThread.prototype = 
{
    run: function() 
    {
        try 
        {
           this.m_HtmlObject.m_Log.Write("HTMLescape.js - run - START");
           this.m_HtmlObject.decode(this.m_HtmlObject.rawMSG);
           this.m_HtmlObject.m_callback(this.m_HtmlObject.m_szRawMSG, this.m_HtmlObject.m_parent);
           this.m_HtmlObject.m_Log.Write("HTMLescape.js - run - END");
        } 
        catch(err) 
        {
             this.m_HtmlObject.DebugDump("HTMLescape.js: run : Exception : "
                                          + err.name
                                          + ".\nError message: "
                                          + err.message +"\n"
                                          + err.lineNumber);
                                          
            this.m_HtmlObject.m_callback(null, this.m_HtmlObject.m_parent );
        }
    },
  
  
    QueryInterface: function(iid) 
    {
        if (iid.equals(Components.interfaces.nsIRunnable) ||
            iid.equals(Components.interfaces.nsISupports)) 
                return this;
                
        throw Components.results.NS_ERROR_NO_INTERFACE;
    }
};

